<script lang="ts">
import AccordionFAQ from './accordion.vue';

export default {
  name: 'PricingFAQ',
  components: { AccordionFAQ },
  props: {
    data: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      groupsData: { visible: false, groups: [] },
      currentHash: '',
    };
  },
  mounted() {
    this.groupsData.groups = this.data.map((group: any, index: number) => ({
      title: group.title,
      id: group.id,
      background: group.background,
      visible: !index,
      items: group.singleAccordionGroupItems.map((item: any) => ({
        ...item,
        expanded: false,
      })),
    }));
  },
  methods: {
    getShowAll(group: any) {
      return group.items.some((item: any) => !item.expanded);
    },
    toggleGroup(index: number, newState: boolean): void {
      const selectedGroup = this.groupsData.groups[index] as any;
      selectedGroup.items = selectedGroup.items.map((question: any) => ({
        ...question,
        expanded: newState,
      }));
    },
    toggleItems(groupIndex: number, itemIndex: number) {
      const selectedQuestion = (this.groupsData.groups[groupIndex] as any)
        .items[itemIndex];
      selectedQuestion.expanded = !selectedQuestion.expanded;
    },
  },
};
</script>

<template>
  <section>
    <div
      v-for="(group, index) in groupsData.groups"
      :id="group.id"
      :key="index"
      class="faq slp-mb-48"
    >
      <div class="faq__gradient-header" />
      <SlpRow class="faq__header">
        <div class="faq__header__anchor">
          <SlpTypography tag="h1" variant="heading3-bold">
            {{ group.title }}
            <router-link :to="{ path: '', hash: group.id }" data-test="ty">
              <SlpIcon
                class="slp-ml-8"
                name="anchor"
                variant="marketing"
                slp-color="text-link-100"
                alt="Anchor Icon"
              />
            </router-link>
          </SlpTypography>
        </div>
        <button
          v-if="getShowAll(group)"
          type="button"
          class="faq__header__action"
          :data-toggle-group="group.title"
          @click="toggleGroup(index, true)"
        >
          <SlpTypography
            variant="body3-bold"
            role="button"
            :aria-label="`Expand all ${group.title} items.`"
          >
            Show All
          </SlpTypography>
        </button>
        <button
          v-else
          class="faq__header__action"
          type="button"
          tabindex="0"
          :aria-label="`Close all ${group.title} items.`"
          @click="toggleGroup(index, false)"
        >
          <SlpTypography variant="body3-bold"> Hide All</SlpTypography>
        </button>
      </SlpRow>
      <SlpRow
        v-for="(item, itemIndex) in group.items"
        :key="`${item.header}-${itemIndex}`"
      >
        <AccordionFAQ
          :data="item"
          :title="group.title"
          :item-index="itemIndex"
          @toggleController="toggleItems(index, itemIndex)"
        />
      </SlpRow>
    </div>
  </section>
</template>

<style scoped lang="scss">
.faq {
  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
  }

  &__header {
    display: flex;
    justify-content: space-between;
    align-items: flex-end;
    padding-bottom: $spacing-32;
    padding-top: $spacing-16;
    flex-wrap: nowrap;

    @media (min-width: $breakpoint-md) {
      align-items: center;
    }

    &__anchor {
      display: flex;
      align-items: center;
      padding-right: 25px;
      a {
        display: inline-block;
        position: absolute;
      }

      @media (min-width: $breakpoint-md) {
        max-width: 100%;
      }

      &:deep .slp-icon {
        opacity: 1;
        transition: opacity 0.5s ease-in-out;
        @media (min-width: $breakpoint-md) {
          opacity: 0;
        }
      }

      &:hover {
        &:deep .slp-icon {
          opacity: 1;
        }
      }
    }

    &__action {
      min-width: 64px;
      padding: 0;
      border: none;
      color: $color-text-link-100;
      transition: all 0.5s ease-in-out;
      cursor: pointer;
      @media (max-width: $breakpoint-md) {
        margin-bottom: -8px;
      }

      &:hover {
        filter: brightness(80%);
        text-decoration: underline;
      }
    }
  }
}
</style>
